package entities;

import java.io.Serializable;
import java.util.Set;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.OneToMany;

@Entity
public class Department implements Serializable {

    @Id
    private Long primKey;
    private String name;

    @OneToMany(cascade=CascadeType.PERSIST, mappedBy="department")
    private Set<Employee> employees;
    
    public Department() {
    }

    public int hashCode() {
        int hash = 0;
        hash += (this.getPrimKey() != null ? this.getPrimKey().hashCode() : 0);
        return hash;
    }

    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Department)) {
            return false;
        }
        Department other = (Department)object;
        if (this.getPrimKey() != other.getPrimKey() && (this.getPrimKey() == null || !this.getPrimKey().equals(other.getPrimKey()))) return false;
        return true;
    }

    public String toString() {
        return "entities.manytoonealloverridden.Department[id=" + getPrimKey() + "]";
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Set<Employee> getEmployees() {
        return employees;
    }

    public void setEmployees(Set<Employee> employees) {
        this.employees = employees;
    }

    public Long getPrimKey() {
        return primKey;
    }

    public void setPrimKey(Long primKey) {
        this.primKey = primKey;
    }
    
}
