package tests;

import entities.Department;
import entities.Employee;
import java.util.HashSet;
import java.util.Set;
import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class TestJoinColumn {
    
    private EntityManagerFactory emf;
    
    private static long DEPT_PRIM_KEY777 = 777l;
    private static String DEPT_NAME777 = "SevenSeventySeven";
    private static long EMP_ID7771 = 34l;
    private static String EMP_CODE7771 = "ThirtyFourEL777";
    private static long EMP_ID8881 = 35l;
    private static String EMP_CODE8881 = "ThirtyFiveEL888";
    
    public TestJoinColumn() {
    }
    
    public void test() {
        try {
            emf = Persistence.createEntityManagerFactory("joincolumn");
            persistRelationship();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    
    private void persistRelationship() {
        Department dept = createDepartment(DEPT_PRIM_KEY777, DEPT_NAME777);
        Employee emp1 = createEmployee(EMP_ID7771, EMP_CODE7771);
        Employee emp2 = createEmployee(EMP_ID8881, EMP_CODE8881);
        Set<Employee> employees = new HashSet();
        employees.add(emp1);
        employees.add(emp2);
        
        dept.setEmployees(employees);
        emp1.setDepartment(dept);
        emp2.setDepartment(dept);
        
        EntityManager em = emf.createEntityManager();
        em.getTransaction().begin();
        em.persist(dept);
        em.getTransaction().commit();
    }
    
    private Employee createEmployee(long id, String code) {
        Employee emp = new Employee();
        emp.setId(id);
        emp.setCode(code);
        return emp;
    }
    
    private Department createDepartment(long primaryKey, String name) {
        Department dept = new Department();
        dept.setPrimKey(primaryKey);
        dept.setName(name);
        return dept;
    }

}
